using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using MeshVR;
using SimpleJSON;
using UnityEngine.PostProcessing;
using UnityEngine.Rendering;
using UnityEngine.UI;
using UnityEngine.Events;
namespace SubsurfaceScatteringSkinBeta8_HuntingSuccubus
{
    public class SSSSkin_HuntingSuccubus : MVRScript
    {
		private Atom _person;
		private DAZCharacterSelector _selector;
        private DAZCharacter _character;
		DAZSkinV2 skin;
        JSONStorableFloat alpha;
        JSONStorableFloat artremvlatency;
        JSONStorableFloat artremvpixbias;
        JSONStorableFloat blurIterations;		
        JSONStorableFloat scatterDistance;		
        JSONStorableFloat scatterIntensity;
        JSONStorableFloat softDepthBias;
        JSONStorableFloat affectDirect;
        JSONStorableFloat _Tess ;		
        JSONStorableFloat _TessPhong   ;	
        JSONStorableFloat _TessellationUniform;
		JSONStorableUrl lookUpTable;
		JSONStorableUrl TextureLoaderFaceUrl;		
		JSONStorableUrl TextureLoaderTorsoUrl;		
		JSONStorableUrl TextureLoaderLimbsUrl;		
		JSONStorableUrl TextureLoaderGensUrl;		
		JSONStorableUrl storable1FaceUrl;
		JSONStorableUrl storable1TorsoUrl;
		JSONStorableUrl storable1LimbsUrl;
		JSONStorableUrl storable1GensUrl;
		
		Texture2D textureFace;
		Texture2D textureTorso;
		Texture2D textureLimbs;
		Texture2D textureGens;
		
        int downscaleval;		
        int blurIterationsval;		
        float scatterDistanceval;		
        float scatterIntensityval;
        float softDepthBiasval;
        float affectDirectval;	
		
        JSONStorableBool enableSSS;
        JSONStorableBool enableSSSCompare;
		JSONStorableBool enableScreenshotCamera;		
		JSONStorableBool enableWindowCamera;
		JSONStorableBool enableWindowCameraHUD;		
		JSONStorableBool enableTessellation;		
		JSONStorableBool diffuseSSS;
		JSONStorableBool decalSSS;		
		
        JSONStorableUrl loadedShaderPath = new JSONStorableUrl("shader", "");
		bool nowStarted = false;
		bool directionalLightFound = false;
        bool loadedAssetBundle;
        bool isLoading;
        int retryAttempts;
		int timer;
		static int scatteringColorID;
      	private static readonly string defaultDir = "Custom/Scripts/Hunting-Succubus/";
        private static readonly string BUNDLE_NAME = "SSSSkinHuntSucMod.assetbundle";
        private static readonly string BUNDLE_NAMEWIP = "SSSSkinHuntSucModWIP.assetbundle";

        protected List<Material[]> ourMaterials = new List<Material[]>();
		public Material test;
        protected Shader shader;
		protected Shader sssshader;
		protected Shader maskShader;
		protected Shader copyDepthShader;
		protected Shader sssshader2;
		protected Shader maskShader2;
		protected Shader copyDepthShader2;
		protected Shader tessShader;		
		protected Shader tessShader2;
		protected Shader tessShader3;		
		protected Shader tessShader4;
		protected Shader tessShader5;
		protected Shader shadowShader;
		protected Shader skyshop;		
		
		public	Material maskmaterial;
		public	Material blurshadermaterial;
		public	Material copyDepthShadermaterial;
		public	Material maskmaterial2;
		public	Material blurshadermaterial2;
		public	Material copyDepthShadermaterial2;	
		Material[] sss1Materials;
		
		public Camera cam;	
		public Camera cam1;			
		public Camera cam2;			
		public Camera cam3;			
		public Camera cam4;			
		public Camera cam5;			
		
			
        protected JSONStorableColor color;

		CommandBuffer buffer;
		CommandBuffer buffer1;		
		CommandBuffer buffer2;		
		CommandBuffer buffer3;		
		CommandBuffer buffer4;		
		CommandBuffer buffer5;		
		
		CameraEvent camEvent = CameraEvent.BeforeImageEffectsOpaque;

        public override void Init()
        {
            try {	
			    if (containingAtom?.type != "Person")
				{
                SuperController.LogError($"This plugin only works on Person atoms");
                DestroyImmediate(this);
                return;
				}
			    _person = containingAtom;
				_selector = _person.GetComponentInChildren<DAZCharacterSelector>();
				_character = _selector.selectedCharacter;
                enableSSS = new JSONStorableBool("Enable Subsurface Scattering", true);
                RegisterBool(enableSSS);
                CreateToggle(enableSSS, false);
				
				diffuseSSS = new JSONStorableBool("Blend Diffuse Tex with SSS Tex", true);
                RegisterBool(diffuseSSS);
                CreateToggle(diffuseSSS, false);				

                enableSSSCompare = new JSONStorableBool("Compare Skin", false, (bool _) => toggleCompare());
                RegisterBool(enableSSSCompare);
                CreateToggle(enableSSSCompare, false);		

				//decalSSS = new JSONStorableBool("Use Decal Tex for SSS", false);
                //RegisterBool(decalSSS);
                //CreateToggle(decalSSS, false);
				
				enableTessellation = new JSONStorableBool("Tessellation", false);
                RegisterBool(enableTessellation);
                CreateToggle(enableTessellation, false);
				
				enableScreenshotCamera = new JSONStorableBool("SSS on Screenshot Camera", true);
                RegisterBool(enableScreenshotCamera);
                CreateToggle(enableScreenshotCamera, false);
				
				enableWindowCamera = new JSONStorableBool("SSS on Window Camera", false);
                RegisterBool(enableWindowCamera);
                CreateToggle(enableWindowCamera, false);	
				
				enableWindowCameraHUD = new JSONStorableBool("SSS on Window Camera HUD", false);
                RegisterBool(enableWindowCameraHUD);
                CreateToggle(enableWindowCameraHUD, false);				
				
                color = new JSONStorableColor("Subdermal Scatter Color", HSVColorPicker.RGBToHSV(1f, 0.5f, 0.5f));
                RegisterColor(color);
                CreateColorPicker(color, true);
		
				blurIterations = new JSONStorableFloat("Blur Iterations", 3f, 0f, 6f, true, true);
				RegisterFloat(blurIterations);
				CreateSlider(blurIterations, true);				
				
				scatterDistance = new JSONStorableFloat("Scatter Distance", 0.051f, 0f, 0.1f, true, true);
				RegisterFloat(scatterDistance);
				CreateSlider(scatterDistance, true);				
				
				scatterIntensity = new JSONStorableFloat("Scatter Intensity", 3f, 0f, 5f, true, true);
				RegisterFloat(scatterIntensity);
				CreateSlider(scatterIntensity, true);				
				
				softDepthBias = new JSONStorableFloat("Soft Depth Bias", 0.001f, 0f, 0.002f, true, true);
				RegisterFloat(softDepthBias);
				CreateSlider(softDepthBias, true);				
				
				affectDirect = new JSONStorableFloat("Color Affect Direct", 0.2f, 0f, 2f, true, true);
				RegisterFloat(affectDirect);
				CreateSlider(affectDirect, true);
								
				artremvlatency = new JSONStorableFloat("Artifact Removal Latency", 20f, 10f, 80f, true, true);
				RegisterFloat(artremvlatency);
				CreateSlider(artremvlatency, true);
				
				artremvpixbias = new JSONStorableFloat("Artifact Removal Pixel Bias", 2f, 1f, 100f, true, true);
				RegisterFloat(artremvpixbias);
				CreateSlider(artremvpixbias, true);		
				
			TextureLoader();	
			
			UIDynamicTextField textfieldversion = CreateTextField(new JSONStorableString("Info", "SubsurfaceScatteringSkin by HuntingSuccubus Beta 10"));
			textfieldversion.height = 12;
			//textfieldversion.textColor = Color.gray;
			UIDynamicTextField textfieldupdate1 = CreateTextField(new JSONStorableString("Info", "Tight Cloth with Tessellation may create artifact,set Cloth Material's render queue to 2550, ***It will also disable Cloth's Shadow"));
			textfieldupdate1.textColor = Color.gray;
			UIDynamicTextField textfieldupdate2 = CreateTextField(new JSONStorableString("Info", "enabling SSS on Window Camera may show blinking artifact but during video recording it will not show."));
			textfieldupdate2.textColor = Color.gray;			
/* 				_Tess  = new JSONStorableFloat("_Tess", 4.0f, 0.0f, 8.0f, true, true);
				RegisterFloat(_Tess);
				CreateSlider(_Tess, true);

				_TessPhong    = new JSONStorableFloat("_TessPhong ", 1.2f, 0.0f, 4.0f, true, true);
				RegisterFloat(_TessPhong );
				CreateSlider(_TessPhong , true);

				_TessellationUniform   = new JSONStorableFloat("_TessellationUniform", 10.0f, 1.0f, 64.0f, true, true);
				RegisterFloat(_TessellationUniform);
				CreateSlider(_TessellationUniform, true); */
				
				StartCoroutine(LoadShaderAndInit());
				//ApplyBuffer();
				timer=1;
                }
             catch (Exception e) {
                SuperController.LogError("Exception caught: " + e);
            }
        }
		
	void fixScalp()
	{var allWraps = containingAtom.gameObject.GetComponentsInChildren<DAZSkinWrap>(false);
		foreach (var wrap in allWraps) 
		{if (wrap.ToString().Contains("Scalp")) 
			{wrap.GPUmaterials[0].renderQueue = 2504;}					   
		}
	}
		
	protected IEnumerator nowStart()
	{	ApplyBuffer();
		if(isLoading)
		StartCoroutine(LoadShaderAndInit());
		else
	  {
		sss1Materials = new Material[skin.GPUmaterials.Length];
		for(int i = 0; i < skin.GPUmaterials.Length; i++)
		sss1Materials[i] = new Material(maskShader2);
	
		//fixScalp();
		nowStarted = true;
/* 		foreach (Light light in FindObjectsOfType<Light>())
		{
		 if(light.type==LightType.Point)
			light.shadowBias = 0f;
		 if(light.type==LightType.Directional)
			{if(light.enabled)
			directionalLightFound = true;}
		}
		if(!directionalLightFound)
		SuperController.LogMessage("No enabled Directional Light found!!! SSS Skin require atleast one Directional Light to function."); */
	  }
	  yield return new WaitForEndOfFrame();
	}	
		
   void Update() // Updating Matterial Buffers
    {if (nowStarted)		
		foreach (Material mat in skin.GPUmaterials)
        {
        if (mat != null && mat.name != "EyeReflection-1" && mat.name != "EyeReflection" && mat.name != "Irises" && mat.name != "Irises-1" && mat.name != "Eyelashes" && mat.name != "Eyelashes-1" && mat.name != "Cornea-1" && mat.name != "Cornea"&& mat.name != "Sclera-1"&& mat.name != "Sclera"&& mat.name != "Pupils-1"&& mat.name != "Pupils" && mat.name != "Tear" && mat.name != "Tear-1" && mat.name != "Teeth-1" && mat.name != "Teeth" && mat.name != "Tongue" && mat.name != "Tongue-1" && mat.name != "InnerMouth-1" && mat.name != "InnerMouth") {
		if(mat.shader.name != "Custom/Subsurface/TransparentGlossNMNoCullSeparateAlphaComputeBuff")
        mat.shader = Shader.Find("Custom/Subsurface/GlossNMTessMappedFixedComputeBuff");
		mat.SetFloat("_Tess", 3.35f);
		mat.SetFloat("_TessPhong", 0.5f);
		skin.BroadcastMessage("OnApplicationFocus", true);
		}
        }	
	}
	
   void LateUpdate() // Updating Matterial Buffers
    {if (nowStarted)
		{
		AddSSS(buffer1,cam1);
		
/* 		AddSSS(buffer1,cam1);
		AddSSS(buffer1,cam1);
		AddSSS(buffer1,cam1);
		AddSSS(buffer1,cam1); */	
		
		if(enableScreenshotCamera.val)
		{
		 if(cam2.enabled)
			AddSSS(buffer2,cam2);
		 if(cam3.enabled)
			AddSSS(buffer3,cam3);	
		}
		else
		{
		 buffer2.Clear();
		 buffer3.Clear();
		}
		
  		if(cam4==null)
		{	
		var foundCamera = FindObjectsOfType<Camera>();
		foreach (Camera fCamera in foundCamera)
		{
			if(fCamera.name=="MiniCamera")
			{
			cam4 = fCamera;
			cam4.depthTextureMode = DepthTextureMode.Depth;
			cam4.AddCommandBuffer(camEvent, buffer4);
			}
		}
		}	
			
		if(cam5==null)
		{	
		var foundCamera = FindObjectsOfType<Camera>();
		foreach (Camera fCamera in foundCamera)
		{
			if(fCamera.name=="MainWindowCamera")
			{
			cam5 = fCamera;
			cam5.depthTextureMode = DepthTextureMode.Depth;
			cam5.AddCommandBuffer(camEvent, buffer5);		
			}
		}
		}		
			if(enableWindowCameraHUD.val)
			{				
			if(cam4!=null&&cam4.enabled)
			AddSSS(buffer4,cam4);
			}
			else
			buffer4.Clear();		
			if(enableWindowCamera.val)
			{				
			if(cam5!=null&&cam5.enabled)
			AddSSS(buffer5,cam5);
			}
			else
			buffer5.Clear();
		}
	}
				
	public void AddMakeSSSMaskCommands(CommandBuffer passedbuffer, Camera passedcam)
	{	
	int maskRT = Shader.PropertyToID("_MaskTex");
		if(passedcam.name=="Camera (eye)"||passedcam.name=="CenterEyeAnchor")
		passedbuffer.GetTemporaryRT(maskRT, passedcam.pixelWidth*2, passedcam.pixelHeight*1, 24, FilterMode.Bilinear, RenderTextureFormat.ARGB32);
		else
		passedbuffer.GetTemporaryRT(maskRT, passedcam.pixelWidth, passedcam.pixelHeight*1, 24, FilterMode.Bilinear, RenderTextureFormat.ARGB32);		
		passedbuffer.Blit(BuiltinRenderTextureType.None, maskRT, new Material(copyDepthShader2));
		passedbuffer.SetRenderTarget(maskRT);	
		maskmaterial.SetColor("ScatteringColor", color.colorPicker.currentColor);
		for (int i = 0; i < skin.GPUmaterials.Length; i++)
		{//skin.GPUmaterials[i].shader = skyshop;
			if(skin.GPUmaterials[i].name == "Head" ||skin.GPUmaterials[i].name == "Hips-2" ||skin.GPUmaterials[i].name == "Genitalia" ||skin.GPUmaterials[i].name == "Genitalia-1" ||skin.GPUmaterials[i].name == "Feet" ||skin.GPUmaterials[i].name == "Feet-1" || skin.GPUmaterials[i].name == "Shoulders"||skin.GPUmaterials[i].name == "Neck" || skin.GPUmaterials[i].name == "Hips"||skin.GPUmaterials[i].name == "Torso" || skin.GPUmaterials[i].name == "Nipples"||skin.GPUmaterials[i].name == "Forearms"||skin.GPUmaterials[i].name == "Tongue"||skin.GPUmaterials[i].name == "Ears"||skin.GPUmaterials[i].name == "Legs"||skin.GPUmaterials[i].name == "Nostrils"||skin.GPUmaterials[i].name == "Lacrimals"||skin.GPUmaterials[i].name == "Lips"||skin.GPUmaterials[i].name == "Face"||skin.GPUmaterials[i].name == "Lacrimals"||skin.GPUmaterials[i].name == "Hands"||skin.GPUmaterials[i].name == "Legs"||skin.GPUmaterials[i].name == "defaultMat"||skin.GPUmaterials[i].name == "Head-1" || skin.GPUmaterials[i].name == "Shoulders-1"||skin.GPUmaterials[i].name == "Neck-1" || skin.GPUmaterials[i].name == "Hips-1"||skin.GPUmaterials[i].name == "Torso-1" || skin.GPUmaterials[i].name == "Nipples-1"||skin.GPUmaterials[i].name == "Forearms-1"||skin.GPUmaterials[i].name == "Tongue-1"||skin.GPUmaterials[i].name == "Ears-1"||skin.GPUmaterials[i].name == "Legs-1"||skin.GPUmaterials[i].name == "Nostrils-1"||skin.GPUmaterials[i].name == "Lacrimals-1"||skin.GPUmaterials[i].name == "Lips-1"||skin.GPUmaterials[i].name == "Face-1"||skin.GPUmaterials[i].name == "Lacrimals-1"||skin.GPUmaterials[i].name == "Hands-1"||skin.GPUmaterials[i].name == "Legs-1"||skin.GPUmaterials[i].name == "defaultMat-1")
			{
			if(enableTessellation.val){
			sss1Materials[i].shader = tessShader4;
			skin.GPUmaterials[i].SetTexture("_TessTex",Texture2D.whiteTexture);
			}
			else{
			sss1Materials[i].shader = maskShader2;
			skin.GPUmaterials[i].SetTexture("_TessTex",Texture2D.blackTexture);			
			//skin.GPUmaterials[i].SetFloat("_Tess", 0f);	
			}
			sss1Materials[i].CopyPropertiesFromMaterial(skin.GPUmaterials[i]);
			sss1Materials[i].SetColor("ScatteringColor", color.colorPicker.currentColor);
			
			if(!diffuseSSS.val)	
			sss1Materials[i].SetTexture("_MainTex", null);
		
			if(skin.GPUmaterials[i].name == "Face-1"||skin.GPUmaterials[i].name == "Lips"||skin.GPUmaterials[i].name == "Lips-1"||skin.GPUmaterials[i].name == "Face")
				if(textureFace)	
				sss1Materials[i].SetTexture("_MainTex2", textureFace);

			if(skin.GPUmaterials[i].name == "Torso"||skin.GPUmaterials[i].name == "Torso-1"||skin.GPUmaterials[i].name == "Nostrils"||skin.GPUmaterials[i].name == "Lacrimals"||skin.GPUmaterials[i].name == "Lacrimals"||skin.GPUmaterials[i].name == "Nostrils-1"||skin.GPUmaterials[i].name == "Lacrimals-1"||skin.GPUmaterials[i].name == "Ears"||skin.GPUmaterials[i].name == "Ears-1"||skin.GPUmaterials[i].name == "Head"||skin.GPUmaterials[i].name == "Head-1" ||skin.GPUmaterials[i].name == "Neck"||skin.GPUmaterials[i].name == "Neck-1"||skin.GPUmaterials[i].name == "Nipples"||skin.GPUmaterials[i].name == "Nipples-1"||skin.GPUmaterials[i].name == "Hips-1"||skin.GPUmaterials[i].name == "Hips"||skin.GPUmaterials[i].name == "Hips-2" )
				if(textureTorso)	
				sss1Materials[i].SetTexture("_MainTex2", textureTorso);
			
			if(skin.GPUmaterials[i].name == "Feet"||skin.GPUmaterials[i].name == "Feet-1"||skin.GPUmaterials[i].name == "Hands"||skin.GPUmaterials[i].name == "Legs"||skin.GPUmaterials[i].name == "Forearms"||skin.GPUmaterials[i].name == "Legs-1"||skin.GPUmaterials[i].name == "Forearms-1"||skin.GPUmaterials[i].name == "Hands-1"||skin.GPUmaterials[i].name == "Legs-1"||skin.GPUmaterials[i].name == "Shoulders"||skin.GPUmaterials[i].name == "Shoulders-1"||skin.GPUmaterials[i].name == "Legs")
				if(textureLimbs)	
				sss1Materials[i].SetTexture("_MainTex2", textureLimbs);
			
			if(skin.GPUmaterials[i].name == "Genitalia"||skin.GPUmaterials[i].name == "Genitalia-1"||skin.GPUmaterials[i].name == "defaultMat"||skin.GPUmaterials[i].name == "defaultMat-1")
				if(textureGens)
				sss1Materials[i].SetTexture("_MainTex2", textureGens);	
				
			
			//if(decalSSS.val)
			//sss1Materials[i].SetTexture("_MainTex", skin.GPUmaterials[i].GetTexture("_DecalTex"));
			
			//sss1Materials[i].renderQueue = skin.GPUmaterials[i].renderQueue;
			//sss1Materials[i].shader = Shader.Find("Hidden/VAMCPSSSSSMask");
			//tessShader
			
			passedbuffer.DrawMesh(skin.Mesh,Matrix4x4.identity, sss1Materials[i], i);
			//if(sss1Materials[i].mainTexture == null) SuperController.LogError("mainTexture=null="+i);
			}
			//Graphics.DrawMesh(skin.Mesh,Matrix4x4.identity, skin.GPUmaterials[3] , 3,cam);
			
		}
		
		passedbuffer.SetGlobalTexture("_MaskTex", maskRT);
	}






	public void AddSSS(CommandBuffer passingbuffer, Camera passingcam)
	  {	passingbuffer.Clear();
		if(enableSSS.val)
		{
		AddMakeSSSMaskCommands(passingbuffer, passingcam);
		
		int blurRT1 = Shader.PropertyToID("_CPSSSSSBlur1");
		int blurRT2 = Shader.PropertyToID("_CPSSSSSBlur2");
		int src = Shader.PropertyToID("_CPSSSSSSource");
		int w = -1;
		int h = -1;
		//SuperController.LogError("TargetCamera="+camlocal.name);
		//cam.nearClipPlane = 0.01f;
		//SuperController.LogMessage(cam.nearClipPlane+"    "+cam.farClipPlane);
		//passingcam.farClipPlane = 200.151f;
		if (passingcam != null && passingbuffer.name == "Screen Space Subsurface Scattering")
		  {//SuperController.LogError("TargetCamera="+passingcam.pixelWidth);
			if(timer<artremvlatency.val)
			{
			w = (int)(passingcam.pixelWidth/ 1);
			h = (int)(passingcam.pixelHeight / 1);
			
			timer++;
			
			}
			else
			{
			w = (int)(passingcam.pixelWidth/ 1);
			h = (int)(passingcam.pixelHeight- (int)artremvpixbias.val);
			timer++;
			}
			if(timer>=artremvlatency.val*2)
			timer=1;
/* 			w = passingcam.pixelWidth*2 / (int)downscale.val;
			h = passingcam.pixelHeight / (int)downscale.val; */
		  }

		passingbuffer.GetTemporaryRT(blurRT1, w, h, 16, FilterMode.Bilinear, RenderTextureFormat.ARGBFloat);
		passingbuffer.GetTemporaryRT(blurRT2, w, h, 16, FilterMode.Bilinear, RenderTextureFormat.ARGBFloat);
		passingbuffer.GetTemporaryRT(src, -1, -1, 24, FilterMode.Bilinear, RenderTextureFormat.ARGBFloat);
		passingbuffer.SetGlobalFloat("_SoftDepthBias", softDepthBias.val * 0.05f * 0.2f);

		passingbuffer.Blit(BuiltinRenderTextureType.CameraTarget, blurRT2);
		//buffer.Blit(BuiltinRenderTextureType.CurrentActive, sourceBuf);
		passingbuffer.Blit(BuiltinRenderTextureType.CameraTarget, src);

		//multipass pass blur
		for (int k = 1; k <= (int)blurIterations.val; k++)
		{	passingbuffer.SetGlobalFloat("_BlurStr", Mathf.Clamp01(scatterDistance.val * 0.08f - k * 0.022f * scatterDistance.val));
			passingbuffer.SetGlobalVector("_BlurVec", new Vector4(1, 0, 0, 0));
			passingbuffer.Blit(blurRT2, blurRT1, new Material(blurshadermaterial2), 0);
			passingbuffer.SetGlobalVector("_BlurVec", new Vector4(0, 1, 0, 0));
			passingbuffer.Blit(blurRT1, blurRT2, new Material(blurshadermaterial2), 0);

			passingbuffer.SetGlobalVector("_BlurVec", new Vector4(1, 1, 0, 0).normalized);
			passingbuffer.Blit(blurRT2, blurRT1, new Material(blurshadermaterial2), 0);
			passingbuffer.SetGlobalVector("_BlurVec", new Vector4(-1, 1, 0, 0).normalized);
			passingbuffer.Blit(blurRT1, blurRT2, new Material(blurshadermaterial2), 0);
		}
		//buffer.Blit(blurRT2, blurBuf);
		passingbuffer.SetGlobalTexture("_BlurTex", blurRT2);
		passingbuffer.SetGlobalFloat("_EffectStr", scatterIntensity.val);
		passingbuffer.SetGlobalFloat("_PreserveOriginal", 1 - affectDirect.val);
		passingbuffer.Blit(src, BuiltinRenderTextureType.CameraTarget, new Material(blurshadermaterial2), 1);
		passingbuffer.ReleaseTemporaryRT(blurRT1);
		passingbuffer.ReleaseTemporaryRT(blurRT2);
		passingbuffer.ReleaseTemporaryRT(src);
		//skin.BroadcastMessage("OnApplicationFocus", true);
		}
	  }


	void ApplyBuffer()
	{
		cam1 = Camera.main;
		cam1.depthTextureMode = DepthTextureMode.Depth;
		buffer1 = new CommandBuffer();
		buffer1.name = "Screen Space Subsurface Scattering";		
		cam1.AddCommandBuffer(camEvent, buffer1);	
		//GetComponent<Camera>().AddCommandBuffer(camEvent, buffer);	
		
		var foundCamera = FindObjectsOfType<Camera>();
		foreach (Camera fCamera in foundCamera)
			{
				//SuperController.LogError("Camera="+fCamera.name+"  active="+fCamera.enabled);
				if(fCamera.name=="LoResScreenshotCamera")
				{
					//SuperController.LogError("TargetCamera="+fCamera.name);	
					//Camera cam2 = fCamera;
					cam2 = fCamera;
					cam2.depthTextureMode = DepthTextureMode.Depth;
					buffer2 = new CommandBuffer();
					buffer2.name = "Screen Space Subsurface Scattering 2";						
					cam2.AddCommandBuffer(camEvent, buffer2);		
				}
				if(fCamera.name=="HiResScreenshotCamera")				
				{
					//SuperController.LogError("TargetCamera="+fCamera.name);	
					//Camera cam2 = fCamera;
					cam3 = fCamera;
					cam3.depthTextureMode = DepthTextureMode.Depth;
					buffer3 = new CommandBuffer();
					buffer3.name = "Screen Space Subsurface Scattering 3";						
					cam3.AddCommandBuffer(camEvent, buffer3);	
				}	
			}
			
		buffer4 = new CommandBuffer();
		buffer4.name = "Screen Space Subsurface Scattering 4";			
		buffer5 = new CommandBuffer();
		buffer5.name = "Screen Space Subsurface Scattering 5";	
	}		
		
	void CleanupBuffer()
	{
		if (buffer1!=null)
		{
		buffer1.Clear();
		cam1.RemoveCommandBuffer(camEvent, buffer1);
		buffer1 = null;
		
		buffer2.Clear();
		cam2.RemoveCommandBuffer(camEvent, buffer2);
		buffer2 = null;		
		
		buffer3.Clear();
		cam3.RemoveCommandBuffer(camEvent, buffer3);
		buffer3 = null;		

		if(cam4!=null)
		{
		buffer4.Clear();
		cam4.RemoveCommandBuffer(camEvent, buffer4);
		buffer4 = null;	
		}
		
		if(cam5!=null)
		{		
		buffer5.Clear();
		cam5.RemoveCommandBuffer(camEvent, buffer5);
		buffer5 = null;	
		}		
		}
	}	

	void OnEnable()
	{
			ApplyBuffer();
	}

	void OnDisable()
	{
			CleanupBuffer();
	}		
	
	void toggleCompare()
	{
		if(enableSSSCompare.val)
		{
		QueueLoadTexture(GetPluginPath()+"/CompareSkin.png",FaceTextureLoaded);		
		QueueLoadTexture(GetPluginPath()+"/CompareSkin.png",TorsoTextureLoaded);	
		QueueLoadTexture(GetPluginPath()+"/CompareLimbsSkin.png",LimbsTextureLoaded);
		QueueLoadTexture(GetPluginPath()+"/CompareSkin.png",GensTextureLoaded);		
		}
		else
		{
		QueueLoadTexture(storable1FaceUrl.val,FaceTextureLoaded);		
		QueueLoadTexture(storable1TorsoUrl.val,TorsoTextureLoaded);
		QueueLoadTexture(storable1LimbsUrl.val,LimbsTextureLoaded);		
		QueueLoadTexture(storable1GensUrl.val,GensTextureLoaded);
		}
	}	
	void TextureLoader()
	{
		string defaultFaceTex = GetPluginPath() + "/DefaultSSSTex.png";
		string defaultTorsoTex = GetPluginPath() + "/DefaultSSSTex.png";		
		string defaultLimbsTex = GetPluginPath() + "/DefaultSSSTex.png";		
		string defaulGenstTex = GetPluginPath() + "/DefaultSSSTex.png";		
	
		
		storable1FaceUrl = new JSONStorableUrl("Load Face Subdermis Texture", defaultFaceTex, (string url) => { QueueLoadTexture(url,FaceTextureLoaded); }, "jpg|png|tif|tiff");
		RegisterUrl(storable1FaceUrl);
		UIDynamicButton button1 = CreateButton("Load Face Subdermis Texture", false);
		storable1FaceUrl.suggestedPath = defaultDir;
		storable1FaceUrl.RegisterFileBrowseButton(button1.button);
		
		storable1TorsoUrl = new JSONStorableUrl("Load Torso Subdermis Texture", defaultTorsoTex, (string url) => { QueueLoadTexture(url,TorsoTextureLoaded); }, "jpg|png|tif|tiff");
		RegisterUrl(storable1TorsoUrl);
		UIDynamicButton button2 = CreateButton("Load Torso Subdermis Texture", false);
		storable1TorsoUrl.suggestedPath = defaultDir;
		storable1TorsoUrl.RegisterFileBrowseButton(button2.button);		
		
		storable1LimbsUrl = new JSONStorableUrl("Load Limbs Subdermis Texture", defaultLimbsTex, (string url) => { QueueLoadTexture(url,LimbsTextureLoaded); }, "jpg|png|tif|tiff");
		RegisterUrl(storable1LimbsUrl);
		UIDynamicButton button3 = CreateButton("Load Limbs Subdermis Texture", false);
		storable1LimbsUrl.suggestedPath = defaultDir;
		storable1LimbsUrl.RegisterFileBrowseButton(button3.button);		
		
		storable1GensUrl = new JSONStorableUrl("Load Gens Subdermis Texture", defaulGenstTex, (string url) => { QueueLoadTexture(url,GensTextureLoaded); }, "jpg|png|tif|tiff");
		RegisterUrl(storable1GensUrl);
		UIDynamicButton button4 = CreateButton("Load Gens Subdermis Texture", false);
		storable1GensUrl.suggestedPath = defaultDir;
		storable1GensUrl.RegisterFileBrowseButton(button4.button);		
		
		
		
		//SetupTexture2DChooser(this, "Load Face Subdermis Texture", defaultFaceTex, false, FaceTextureLoaded);
		//SetupTexture2DChooser(this, "Load Torso Subdermis Texture", defaultTorsoTex, false, TorsoTextureLoaded);		
		//SetupTexture2DChooser(this, "Load Limbs Subdermis Texture", defaultLimbsTex, false, LimbsTextureLoaded);		
		//SetupTexture2DChooser(this, "Load Gens Subdermis Texture", defaulGenstTex, false, GensTextureLoaded);		
		
		QueueLoadTexture(defaultFaceTex,FaceTextureLoaded);		
		QueueLoadTexture(defaultTorsoTex,TorsoTextureLoaded);		
		QueueLoadTexture(defaultLimbsTex,LimbsTextureLoaded);		
		QueueLoadTexture(defaulGenstTex,GensTextureLoaded);				
	}

	public static JSONStorableUrl SetupTexture2DChooser(MVRScript self, string label, string defaultValue, bool rightSide, TextureSetCallback callback)
	{
			JSONStorableUrl storable = new JSONStorableUrl(label, defaultValue, (string url) => { QueueLoadTexture(url,callback); }, "jpg|png|tif|tiff");
			self.RegisterUrl(storable);
			//SuperController.LogError(defaultValue);	
			UIDynamicButton button = self.CreateButton(label, false);
			storable.suggestedPath = defaultDir;
			storable.RegisterFileBrowseButton(button.button);
			return storable;
	}



		private static void QueueLoadTexture(string url,TextureSetCallback callback)
		{	
			if (ImageLoaderThreaded.singleton == null)
			{
				return;
			}
			if (string.IsNullOrEmpty(url))
			{	
				return;
			}
			ImageLoaderThreaded.QueuedImage queuedImage = new ImageLoaderThreaded.QueuedImage();
			queuedImage.imgPath = url;	
			//SuperController.LogError(url);	
			queuedImage.forceReload = true;
			queuedImage.skipCache = true;
			queuedImage.compress = false;
			queuedImage.createMipMaps = false;
			queuedImage.isNormalMap = false;			
			queuedImage.linear = true;
			queuedImage.createAlphaFromGrayscale = false;
			queuedImage.createNormalFromBump = false;
			queuedImage.bumpStrength = 1.0f;
			queuedImage.isThumbnail = false;
			queuedImage.fillBackground = false;
			queuedImage.invert = false;
			queuedImage.callback = (ImageLoaderThreaded.QueuedImage qi) =>
			{
				Texture2D tex = qi.tex;
				if (tex != null)
				{	
					tex.wrapMode = TextureWrapMode.Clamp;
					tex.filterMode = FilterMode.Trilinear;
					tex.anisoLevel = 0;
				}						
				callback(tex);
			};
			ImageLoaderThreaded.singleton.QueueImage(queuedImage);			
		}

	public delegate void TextureSetCallback(Texture2D tex);
	
			private void FaceTextureLoaded(Texture2D tex)
			{		
				textureFace = tex;
			}

 			private void TorsoTextureLoaded(Texture2D tex)
			{	
				textureTorso = tex;
			}      		
		
			private void LimbsTextureLoaded(Texture2D tex)
			{		
				textureLimbs = tex;
			}		
		
			private void GensTextureLoaded(Texture2D tex)
			{	
			textureGens = tex;
			}		
		
		
		
		
		
		
		
		
//////////////////////  AssetLoader/////////////////////////////////////////
	
	
       class LoadAssetBundle : CustomYieldInstruction {
            AssetLoader.AssetBundleFromFileRequest req;
            private bool done;
            // We can't write the type AssetBundle, but we can call methods on it. lolwut C#
            public bool success => req.assetBundle != null;
            public T GetAsset<T>(string name) where T : UnityEngine.Object
            {
                return req.assetBundle?.LoadAsset<T>(name);
            }
            public LoadAssetBundle(string url)
            {
                req = new AssetLoader.AssetBundleFromFileRequest {
                    path = url,
                    callback = _ => {
                        done = true;
                        if (req.assetBundle == null)
                            AssetLoader.DoneWithAssetBundleFromFile(req.path);
                    }
                };
                AssetLoader.QueueLoadAssetBundleFromFile(req);
            }
            public override bool keepWaiting => !done;
        }
	        private IEnumerator AttemptLoadShader(string url)
        {              
            if (shader != null)
                yield break;
            var request = new LoadAssetBundle(url);
            yield return StartCoroutine(request);
            if (!request.success)
                yield break;
            shader = request.GetAsset<Shader>("Assets/EmissiveHack.shader");
			//shader = request.GetAsset<Shader>("Assets/Marmoset/Shader/Beta/Skin/skyshop.shader");
			sssshader = request.GetAsset<Shader>("Assets/Resources folder/CP_SSSSS-master/CP_SSSSS_Shader.shader");
            maskShader = request.GetAsset<Shader>("Assets/Resources folder/CP_SSSSS-master/CP_SSSSS_Mask.shader");			
            copyDepthShader = request.GetAsset<Shader>("Assets/Resources folder/CP_SSSSS-master/CP_SSSSS_BlitDepthTextureToDepth.shader");
            sssshader2 = request.GetAsset<Shader>("Assets/Resources folder/CP_SSSSS-master/CP_VR_SSSSS_Shader.shader");
            maskShader2 = request.GetAsset<Shader>("Assets/Resources folder/CP_SSSSS-master/VAMCP_VR_SSSSS_Mask.shader");			
            copyDepthShader2 = request.GetAsset<Shader>("Assets/Resources folder/CP_SSSSS-master/VAMCP_SSSSS_BlitDepthTextureToDepth.shader");	
            tessShader = request.GetAsset<Shader>("Assets/Resources folder/CP_SSSSS-master/GeneratedFromSurface-TessellationBumpedSpecularSmooth2222.shader");
            tessShader2 = request.GetAsset<Shader>("Assets/Resources folder/CP_SSSSS-master/TessellationBumpedSpecularSmooth2222.shader");
            tessShader3 = request.GetAsset<Shader>("Assets/Shaders/TessellationSample.shader");
			
			if(Camera.main.name=="Camera (eye)"||Camera.main.name=="CenterEyeAnchor")
			{
            tessShader4 = request.GetAsset<Shader>("Assets/Shaders/GeneratedFromSurface-TessellationSample3.shader");
			}
			else
			{
            tessShader4 = request.GetAsset<Shader>("Assets/Shaders/GeneratedFromSurface-TessellationSample3.shader");
			}
		
			shadowShader = request.GetAsset<Shader>("Assets/Shaders/UnlitWithShadowcaster2.shader");
			skyshop = request.GetAsset<Shader>("Assets/Marmoset/Shader/Beta/Skin/skyshop2.shader");		
			
			maskmaterial = new Material(maskShader);
			maskmaterial.SetColor("ScatteringColor", Color.red);
			blurshadermaterial = new Material(sssshader);
			copyDepthShadermaterial = new Material(copyDepthShader);
			maskmaterial2 = new Material(maskShader2);
			maskmaterial2.SetColor("ScatteringColor", Color.red);
			blurshadermaterial2 = new Material(sssshader2);
			copyDepthShadermaterial2 = new Material(copyDepthShader2);
		
			
            if (shader != null) {
                loadedShaderPath.val = url;
                loadedAssetBundle = true;
            } else {
                SuperController.LogError("Not found location in  assetbundle,this error occurs when diff plugin version is used in same session(save scene and restart vam). User should extract VAR package and select script from there!");
                AssetLoader.DoneWithAssetBundleFromFile(url);
            }
        }
		
		
        string GetPluginPath() // basically straight from VAMDeluxe's Dollmaster
        {
            string pluginId = this.storeId.Split('_')[0];
            string pathToScriptFile = manager.GetJSON(true, true)["plugins"][pluginId].Value;
            string pathToScriptFolder = pathToScriptFile.Substring(0, pathToScriptFile.LastIndexOfAny(new char[] { '/', '\\' }));
            return pathToScriptFolder;
        }		
		
	     protected IEnumerator LoadShaderAndInit()
        {
			yield return new WaitForEndOfFrame();
			if (shader == null) 
			{
                if (loadedShaderPath.val != "")
                    yield return AttemptLoadShader(loadedShaderPath.val);
				//SuperController.LogError("path"+GetPluginPath());

              // yield return AttemptLoadShader($"Custom/Scripts/Hunting-Succubus/{BUNDLE_NAMEWIP}");
			    yield return AttemptLoadShader($"{GetPluginPath()}/{BUNDLE_NAMEWIP}");
              yield return AttemptLoadShader($"{GetPluginPath()}/{BUNDLE_NAME}");
				
                if (shader == null || maskShader == null || copyDepthShader == null) 
				{
                    SuperController.LogError("main.Failed to load shader,this error occurs when diff plugin version is used in same session(save scene and restart vam). User can extract VAR package and select script from there!");
                    yield break;
                }
            }
			skin = _character.skin;
			
			if (skin == null)
			isLoading = true;
			else
			isLoading = false;
		
			StartCoroutine(QueueRescan());
        }	

	  private IEnumerator QueueRescan()
        {
         if (retryAttempts < 5 || (isLoading && retryAttempts < 200)) 
			{
             yield return new WaitForSeconds(0.2f);
             retryAttempts++;
             yield return nowStart();
            }
        }
		
		
    }

}