using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using MeshVR;
using SimpleJSON;
using UnityEngine.PostProcessing;
using UnityEngine.Rendering;
using UnityEngine.UI;
using UnityEngine.Events;
namespace SSSSkin_HuntingSuccubus
{
    public class SSSSkin_HuntingSuccubus : MVRScript
    {
		private Atom _person;
		private DAZCharacterSelector _selector;
        private DAZCharacter _character;
		DAZSkinV2 skin;
        JSONStorableFloat alpha;
        JSONStorableFloat downscale;		
        JSONStorableFloat blurIterations;		
        JSONStorableFloat scatterDistance;		
        JSONStorableFloat scatterIntensity;
        JSONStorableFloat softDepthBias;
        JSONStorableFloat affectDirect;
        JSONStorableFloat _Tess ;		
        JSONStorableFloat _TessPhong   ;	
        JSONStorableFloat _TessellationUniform;
		JSONStorableUrl lookUpTable;
		JSONStorableUrl TextureLoaderFaceUrl;		
		JSONStorableUrl TextureLoaderTorsoUrl;		
		JSONStorableUrl TextureLoaderLimbsUrl;		
		JSONStorableUrl TextureLoaderGensUrl;		
		JSONStorableUrl storable1FaceUrl;
		JSONStorableUrl storable1TorsoUrl;
		JSONStorableUrl storable1LimbsUrl;
		JSONStorableUrl storable1GensUrl;
		
		Texture2D textureFace;
		Texture2D textureTorso;
		Texture2D textureLimbs;
		Texture2D textureGens;
		
        int downscaleval;		
        int blurIterationsval;		
        float scatterDistanceval;		
        float scatterIntensityval;
        float softDepthBiasval;
        float affectDirectval;	
		
        JSONStorableBool enableSSS;
        JSONStorableBool enableSSSCompare;		
		JSONStorableBool enableTessellation;
		JSONStorableBool diffuseSSS;
		JSONStorableBool decalSSS;		
		
        JSONStorableUrl loadedShaderPath = new JSONStorableUrl("shader", "");
		bool nowStarted = false;
		bool directionalLightFound = false;
        bool loadedAssetBundle;
        bool isLoading;
        int retryAttempts;
		static int scatteringColorID;
      	private static readonly string defaultDir = "Custom/Scripts/Hunting-Succubus/";
        private static readonly string BUNDLE_NAME = "SSSSkinHuntSucMod.assetbundle";
        private static readonly string BUNDLE_NAMEWIP = "SSSSkinHuntSucModWIP.assetbundle";

        protected List<Material[]> ourMaterials = new List<Material[]>();
		public Material test;
        protected Shader shader;
		protected Shader sssshader;
		protected Shader maskShader;
		protected Shader copyDepthShader;
		protected Shader sssshader2;
		protected Shader maskShader2;
		protected Shader copyDepthShader2;
		protected Shader tessShader;		
		protected Shader tessShader2;
		protected Shader tessShader3;		
		protected Shader tessShader4;
		protected Shader tessShader5;
		protected Shader shadowShader;
		
		public	Material maskmaterial;
		public	Material blurshadermaterial;
		public	Material copyDepthShadermaterial;
		public	Material maskmaterial2;
		public	Material blurshadermaterial2;
		public	Material copyDepthShadermaterial2;	
		Material[] sss1Materials;
		
		public Camera cam;	
			
        protected JSONStorableColor color;

		CommandBuffer buffer;
		CameraEvent camEvent = CameraEvent.BeforeImageEffectsOpaque;

        public override void Init()
        {
            try {	
			    _person = containingAtom;
				_selector = _person.GetComponentInChildren<DAZCharacterSelector>();
				_character = _selector.selectedCharacter;
                enableSSS = new JSONStorableBool("Enable Subsurface Scattering", true);
                RegisterBool(enableSSS);
                CreateToggle(enableSSS, false);
				
				diffuseSSS = new JSONStorableBool("Blend Diffuse Tex with SSS Tex", true);
                RegisterBool(diffuseSSS);
                CreateToggle(diffuseSSS, false);				

                enableSSSCompare = new JSONStorableBool("Compare Skin", false, (bool _) => toggleCompare());
                RegisterBool(enableSSSCompare);
                CreateToggle(enableSSSCompare, false);		

				//decalSSS = new JSONStorableBool("Use Decal Tex for SSS", false);
                //RegisterBool(decalSSS);
                //CreateToggle(decalSSS, false);
				
				enableTessellation = new JSONStorableBool("Tessellation", false);
                RegisterBool(enableTessellation);
                CreateToggle(enableTessellation, false);
				
                color = new JSONStorableColor("Subdermal Scatter Color", HSVColorPicker.RGBToHSV(1f, 0.5f, 0.5f));
                RegisterColor(color);
                CreateColorPicker(color, true);
				
				downscale = new JSONStorableFloat("Resolution Downscale", 1f, 1f, 4f, true, true);
				RegisterFloat(downscale);
				CreateSlider(downscale, true);
				
				blurIterations = new JSONStorableFloat("Blur Iterations", 3f, 0f, 6f, true, true);
				RegisterFloat(blurIterations);
				CreateSlider(blurIterations, true);				
				
				scatterDistance = new JSONStorableFloat("Scatter Distance", 0.051f, 0f, 0.1f, true, true);
				RegisterFloat(scatterDistance);
				CreateSlider(scatterDistance, true);				
				
				scatterIntensity = new JSONStorableFloat("Scatter Intensity", 3f, 0f, 5f, true, true);
				RegisterFloat(scatterIntensity);
				CreateSlider(scatterIntensity, true);				
				
				softDepthBias = new JSONStorableFloat("Soft Depth Bias", 0.001f, 0f, 0.002f, true, true);
				RegisterFloat(softDepthBias);
				CreateSlider(softDepthBias, true);				
				
				affectDirect = new JSONStorableFloat("Color Affect Direct", 0.2f, 0f, 2f, true, true);
				RegisterFloat(affectDirect);
				CreateSlider(affectDirect, true);
				
			TextureLoader();	
			
			UIDynamicTextField textfieldversion = CreateTextField(new JSONStorableString("Info", "SubsurfaceScatteringSkin by HuntingSuccubus Beta 3"));
			textfieldversion.height = 12;
			//textfieldversion.textColor = Color.gray;
			UIDynamicTextField textfieldupdate1 = CreateTextField(new JSONStorableString("Info", "Tight Cloth with Tessellation may create artifact,set Cloth Material's render queue to 2550, ***It will also disable CLOTH SHADOW"));
			textfieldupdate1.textColor = Color.gray;
			
/* 				_Tess  = new JSONStorableFloat("_Tess", 4.0f, 0.0f, 8.0f, true, true);
				RegisterFloat(_Tess);
				CreateSlider(_Tess, true);

				_TessPhong    = new JSONStorableFloat("_TessPhong ", 1.2f, 0.0f, 4.0f, true, true);
				RegisterFloat(_TessPhong );
				CreateSlider(_TessPhong , true);

				_TessellationUniform   = new JSONStorableFloat("_TessellationUniform", 10.0f, 1.0f, 64.0f, true, true);
				RegisterFloat(_TessellationUniform);
				CreateSlider(_TessellationUniform, true); */
				
				StartCoroutine(LoadShaderAndInit());
				ApplyBuffer();

                }
             catch (Exception e) {
                SuperController.LogError("Exception caught: " + e);
            }
        }
		
	void fixScalp()
	{var allWraps = containingAtom.gameObject.GetComponentsInChildren<DAZSkinWrap>(false);
		foreach (var wrap in allWraps) 
		{if (wrap.ToString().Contains("Scalp")) 
			{wrap.GPUmaterials[0].renderQueue = 2504;}					   
		}
	}
		
	protected IEnumerator nowStart()
	{	
		if(isLoading)
		StartCoroutine(LoadShaderAndInit());
		else
	  {
		sss1Materials = new Material[skin.GPUmaterials.Length];
		for(int i = 0; i < skin.GPUmaterials.Length; i++)
		sss1Materials[i] = new Material(maskShader2);
	
		//fixScalp();
		nowStarted = true;
/* 		foreach (Light light in FindObjectsOfType<Light>())
		{
		 if(light.type==LightType.Point)
			light.shadowBias = 0f;
		 if(light.type==LightType.Directional)
			{if(light.enabled)
			directionalLightFound = true;}
		}
		if(!directionalLightFound)
		SuperController.LogMessage("No enabled Directional Light found!!! SSS Skin require atleast one Directional Light to function."); */
	  }
	  yield return new WaitForEndOfFrame();
	}	
		
   void LateUpdate() // Updating Matterial Buffers
    {if (nowStarted)
	  {	buffer.Clear();
		if(enableSSS.val)
		{
		AddMakeSSSMaskCommands(buffer);
		
		int blurRT1 = Shader.PropertyToID("_CPSSSSSBlur1");
		int blurRT2 = Shader.PropertyToID("_CPSSSSSBlur2");
		int src = Shader.PropertyToID("_CPSSSSSSource");
		int w = -1;
		int h = -1;
		Camera cam = this.cam;
		//cam.nearClipPlane = 0.01f;
		//SuperController.LogMessage(cam.nearClipPlane+"    "+cam.farClipPlane);
		//cam.farClipPlane = 200.151f;
		if (cam != null)
		  {
			w = cam.pixelWidth / (int)downscale.val;
			h = cam.pixelHeight / (int)downscale.val;
		  }

		buffer.GetTemporaryRT(blurRT1, w, h, 16, FilterMode.Bilinear, RenderTextureFormat.ARGBFloat);
		buffer.GetTemporaryRT(blurRT2, w, h, 16, FilterMode.Bilinear, RenderTextureFormat.ARGBFloat);
		buffer.GetTemporaryRT(src, -1, -1, 24, FilterMode.Bilinear, RenderTextureFormat.ARGBFloat);
		buffer.SetGlobalFloat("_SoftDepthBias", softDepthBias.val * 0.05f * 0.2f);

		buffer.Blit(BuiltinRenderTextureType.CameraTarget, blurRT2);
		//buffer.Blit(BuiltinRenderTextureType.CurrentActive, sourceBuf);
		buffer.Blit(BuiltinRenderTextureType.CameraTarget, src);

		//multipass pass blur
		for (int k = 1; k <= (int)blurIterations.val; k++)
		{	buffer.SetGlobalFloat("_BlurStr", Mathf.Clamp01(scatterDistance.val * 0.08f - k * 0.022f * scatterDistance.val));
			buffer.SetGlobalVector("_BlurVec", new Vector4(1, 0, 0, 0));
			buffer.Blit(blurRT2, blurRT1, new Material(blurshadermaterial2), 0);
			buffer.SetGlobalVector("_BlurVec", new Vector4(0, 1, 0, 0));
			buffer.Blit(blurRT1, blurRT2, new Material(blurshadermaterial2), 0);

			buffer.SetGlobalVector("_BlurVec", new Vector4(1, 1, 0, 0).normalized);
			buffer.Blit(blurRT2, blurRT1, new Material(blurshadermaterial2), 0);
			buffer.SetGlobalVector("_BlurVec", new Vector4(-1, 1, 0, 0).normalized);
			buffer.Blit(blurRT1, blurRT2, new Material(blurshadermaterial2), 0);
		}
		//buffer.Blit(blurRT2, blurBuf);
		buffer.SetGlobalTexture("_BlurTex", blurRT2);
		buffer.SetGlobalFloat("_EffectStr", scatterIntensity.val);
		buffer.SetGlobalFloat("_PreserveOriginal", 1 - affectDirect.val);
		buffer.Blit(src, BuiltinRenderTextureType.CameraTarget, new Material(blurshadermaterial2), 1);
		buffer.ReleaseTemporaryRT(blurRT1);
		buffer.ReleaseTemporaryRT(blurRT2);
		buffer.ReleaseTemporaryRT(src);
		//skin.BroadcastMessage("OnApplicationFocus", true);
		}
	  }
	}
				
	public void AddMakeSSSMaskCommands(CommandBuffer buffer)
	{	int maskRT = Shader.PropertyToID("_MaskTex");
		if(cam.name=="Camera (eye)")
		buffer.GetTemporaryRT(maskRT, cam.pixelWidth*2, cam.pixelHeight*1, 24, FilterMode.Bilinear, RenderTextureFormat.ARGB32);
		else
		buffer.GetTemporaryRT(maskRT, cam.pixelWidth, cam.pixelHeight*1, 24, FilterMode.Bilinear, RenderTextureFormat.ARGB32);		
		buffer.Blit(BuiltinRenderTextureType.None, maskRT, new Material(copyDepthShader2));
		buffer.SetRenderTarget(maskRT);	
		maskmaterial.SetColor("ScatteringColor", color.colorPicker.currentColor);
		for (int i = 0; i < skin.GPUmaterials.Length; i++)
		{	
			if(skin.GPUmaterials[i].name == "Head" ||skin.GPUmaterials[i].name == "Hips-2" ||skin.GPUmaterials[i].name == "Genitalia" ||skin.GPUmaterials[i].name == "Genitalia-1" ||skin.GPUmaterials[i].name == "Feet" ||skin.GPUmaterials[i].name == "Feet-1" || skin.GPUmaterials[i].name == "Shoulders"||skin.GPUmaterials[i].name == "Neck" || skin.GPUmaterials[i].name == "Hips"||skin.GPUmaterials[i].name == "Torso" || skin.GPUmaterials[i].name == "Nipples"||skin.GPUmaterials[i].name == "Forearms"||skin.GPUmaterials[i].name == "Tongue"||skin.GPUmaterials[i].name == "Ears"||skin.GPUmaterials[i].name == "Legs"||skin.GPUmaterials[i].name == "Nostrils"||skin.GPUmaterials[i].name == "Lacrimals"||skin.GPUmaterials[i].name == "Lips"||skin.GPUmaterials[i].name == "Face"||skin.GPUmaterials[i].name == "Lacrimals"||skin.GPUmaterials[i].name == "Hands"||skin.GPUmaterials[i].name == "Legs"||skin.GPUmaterials[i].name == "defaultMat"||skin.GPUmaterials[i].name == "Head-1" || skin.GPUmaterials[i].name == "Shoulders-1"||skin.GPUmaterials[i].name == "Neck-1" || skin.GPUmaterials[i].name == "Hips-1"||skin.GPUmaterials[i].name == "Torso-1" || skin.GPUmaterials[i].name == "Nipples-1"||skin.GPUmaterials[i].name == "Forearms-1"||skin.GPUmaterials[i].name == "Tongue-1"||skin.GPUmaterials[i].name == "Ears-1"||skin.GPUmaterials[i].name == "Legs-1"||skin.GPUmaterials[i].name == "Nostrils-1"||skin.GPUmaterials[i].name == "Lacrimals-1"||skin.GPUmaterials[i].name == "Lips-1"||skin.GPUmaterials[i].name == "Face-1"||skin.GPUmaterials[i].name == "Lacrimals-1"||skin.GPUmaterials[i].name == "Hands-1"||skin.GPUmaterials[i].name == "Legs-1"||skin.GPUmaterials[i].name == "defaultMat-1")
			{
			if(enableTessellation.val){
			sss1Materials[i].shader = tessShader4;
			skin.GPUmaterials[i].SetTexture("_TessTex",Texture2D.whiteTexture);
			skin.GPUmaterials[i].SetFloat("_Tess", 3.35f);	
			}
			else{
			sss1Materials[i].shader = maskShader2;
			skin.GPUmaterials[i].SetTexture("_TessTex",Texture2D.blackTexture);			
			skin.GPUmaterials[i].SetFloat("_Tess", 0f);	
			}
			sss1Materials[i].CopyPropertiesFromMaterial(skin.GPUmaterials[i]);
			sss1Materials[i].SetColor("ScatteringColor", color.colorPicker.currentColor);
			sss1Materials[i].SetFloat("_Tess", 4f);
			sss1Materials[i].SetFloat("_TessPhong",1.2f);
			if(!diffuseSSS.val)	
			sss1Materials[i].SetTexture("_MainTex", null);
		
			if(skin.GPUmaterials[i].name == "Face-1"||skin.GPUmaterials[i].name == "Lips"||skin.GPUmaterials[i].name == "Lips-1"||skin.GPUmaterials[i].name == "Face")
				if(textureFace)	
				sss1Materials[i].SetTexture("_MainTex2", textureFace);

			if(skin.GPUmaterials[i].name == "Torso"||skin.GPUmaterials[i].name == "Torso-1"||skin.GPUmaterials[i].name == "Nostrils"||skin.GPUmaterials[i].name == "Lacrimals"||skin.GPUmaterials[i].name == "Lacrimals"||skin.GPUmaterials[i].name == "Nostrils-1"||skin.GPUmaterials[i].name == "Lacrimals-1"||skin.GPUmaterials[i].name == "Ears"||skin.GPUmaterials[i].name == "Ears-1"||skin.GPUmaterials[i].name == "Head"||skin.GPUmaterials[i].name == "Head-1" ||skin.GPUmaterials[i].name == "Neck"||skin.GPUmaterials[i].name == "Neck-1"||skin.GPUmaterials[i].name == "Nipples"||skin.GPUmaterials[i].name == "Nipples-1"||skin.GPUmaterials[i].name == "Hips-1"||skin.GPUmaterials[i].name == "Hips"||skin.GPUmaterials[i].name == "Hips-2" )
				if(textureTorso)	
				sss1Materials[i].SetTexture("_MainTex2", textureTorso);
			
			if(skin.GPUmaterials[i].name == "Feet"||skin.GPUmaterials[i].name == "Feet-1"||skin.GPUmaterials[i].name == "Hands"||skin.GPUmaterials[i].name == "Legs"||skin.GPUmaterials[i].name == "Forearms"||skin.GPUmaterials[i].name == "Legs-1"||skin.GPUmaterials[i].name == "Forearms-1"||skin.GPUmaterials[i].name == "Hands-1"||skin.GPUmaterials[i].name == "Legs-1"||skin.GPUmaterials[i].name == "Shoulders"||skin.GPUmaterials[i].name == "Shoulders-1"||skin.GPUmaterials[i].name == "Legs")
				if(textureLimbs)	
				sss1Materials[i].SetTexture("_MainTex2", textureLimbs);
			
			if(skin.GPUmaterials[i].name == "Genitalia"||skin.GPUmaterials[i].name == "Genitalia-1"||skin.GPUmaterials[i].name == "defaultMat"||skin.GPUmaterials[i].name == "defaultMat-1")
				if(textureGens)
				sss1Materials[i].SetTexture("_MainTex2", textureGens);	
				
			
			//if(decalSSS.val)
			//sss1Materials[i].SetTexture("_MainTex", skin.GPUmaterials[i].GetTexture("_DecalTex"));
			
			//sss1Materials[i].renderQueue = skin.GPUmaterials[i].renderQueue;
			//sss1Materials[i].shader = Shader.Find("Hidden/VAMCPSSSSSMask");
			//tessShader
			
			buffer.DrawMesh(skin.Mesh,Matrix4x4.identity, sss1Materials[i], i);
			//if(sss1Materials[i].mainTexture == null) SuperController.LogError("mainTexture=null="+i);
			}
			//Graphics.DrawMesh(skin.Mesh,Matrix4x4.identity, skin.GPUmaterials[3] , 3,cam);
			
		}
		
		buffer.SetGlobalTexture("_MaskTex", maskRT);

	}	
	
	void ApplyBuffer()
	{
		buffer = new CommandBuffer();
		buffer.name = "Screen Space Subsurface Scattering";
		
		var foundCamera = FindObjectsOfType<Camera>();
		foreach (Camera fCamera in foundCamera)
			{
			//	SuperController.LogError("Camera="+fCamera.name);
				if(fCamera.name=="HiResScreenshotCamera")
				{
					//SuperController.LogError("TargetCamera="+fCamera.name);	
					//Camera cam2 = fCamera;
					cam = fCamera;
				}
			}
		
		//cam = Camera.main;
		cam.depthTextureMode = DepthTextureMode.Depth;
		//GetComponent<Camera>().AddCommandBuffer(camEvent, buffer);	
		cam.AddCommandBuffer(camEvent, buffer);	
	}		
		
	void CleanupBuffer()
	{
		if (buffer!=null)
		{
		buffer.Clear();
		cam.RemoveCommandBuffer(camEvent, buffer);
		buffer = null;
		}
	}	

	void OnEnable()
	{
			ApplyBuffer();
	}

	void OnDisable()
	{
			CleanupBuffer();
	}		
	
	void toggleCompare()
	{
		if(enableSSSCompare.val)
		{
		QueueLoadTexture(GetPluginPath()+"/CompareSkin.png",FaceTextureLoaded);		
		QueueLoadTexture(GetPluginPath()+"/CompareSkin.png",TorsoTextureLoaded);	
		QueueLoadTexture(GetPluginPath()+"/CompareLimbsSkin.png",LimbsTextureLoaded);
		QueueLoadTexture(GetPluginPath()+"/CompareSkin.png",GensTextureLoaded);		
		}
		else
		{
		QueueLoadTexture(storable1FaceUrl.val,FaceTextureLoaded);		
		QueueLoadTexture(storable1TorsoUrl.val,TorsoTextureLoaded);
		QueueLoadTexture(storable1LimbsUrl.val,LimbsTextureLoaded);		
		QueueLoadTexture(storable1GensUrl.val,GensTextureLoaded);
		}
	}	
	void TextureLoader()
	{
		string defaultFaceTex = GetPluginPath() + "/DefaultSSSTex.png";
		string defaultTorsoTex = GetPluginPath() + "/DefaultSSSTex.png";		
		string defaultLimbsTex = GetPluginPath() + "/DefaultSSSTex.png";		
		string defaulGenstTex = GetPluginPath() + "/DefaultSSSTex.png";		
	
		
		storable1FaceUrl = new JSONStorableUrl("Load Face Subdermis Texture", defaultFaceTex, (string url) => { QueueLoadTexture(url,FaceTextureLoaded); }, "jpg|png|tif|tiff");
		RegisterUrl(storable1FaceUrl);
		UIDynamicButton button1 = CreateButton("Load Face Subdermis Texture", false);
		storable1FaceUrl.suggestedPath = defaultDir;
		storable1FaceUrl.RegisterFileBrowseButton(button1.button);
		
		storable1TorsoUrl = new JSONStorableUrl("Load Torso Subdermis Texture", defaultTorsoTex, (string url) => { QueueLoadTexture(url,TorsoTextureLoaded); }, "jpg|png|tif|tiff");
		RegisterUrl(storable1TorsoUrl);
		UIDynamicButton button2 = CreateButton("Load Torso Subdermis Texture", false);
		storable1TorsoUrl.suggestedPath = defaultDir;
		storable1TorsoUrl.RegisterFileBrowseButton(button2.button);		
		
		storable1LimbsUrl = new JSONStorableUrl("Load Limbs Subdermis Texture", defaultLimbsTex, (string url) => { QueueLoadTexture(url,LimbsTextureLoaded); }, "jpg|png|tif|tiff");
		RegisterUrl(storable1LimbsUrl);
		UIDynamicButton button3 = CreateButton("Load Limbs Subdermis Texture", false);
		storable1LimbsUrl.suggestedPath = defaultDir;
		storable1LimbsUrl.RegisterFileBrowseButton(button3.button);		
		
		storable1GensUrl = new JSONStorableUrl("Load Gens Subdermis Texture", defaulGenstTex, (string url) => { QueueLoadTexture(url,GensTextureLoaded); }, "jpg|png|tif|tiff");
		RegisterUrl(storable1GensUrl);
		UIDynamicButton button4 = CreateButton("Load Gens Subdermis Texture", false);
		storable1GensUrl.suggestedPath = defaultDir;
		storable1GensUrl.RegisterFileBrowseButton(button4.button);		
		
		
		
		//SetupTexture2DChooser(this, "Load Face Subdermis Texture", defaultFaceTex, false, FaceTextureLoaded);
		//SetupTexture2DChooser(this, "Load Torso Subdermis Texture", defaultTorsoTex, false, TorsoTextureLoaded);		
		//SetupTexture2DChooser(this, "Load Limbs Subdermis Texture", defaultLimbsTex, false, LimbsTextureLoaded);		
		//SetupTexture2DChooser(this, "Load Gens Subdermis Texture", defaulGenstTex, false, GensTextureLoaded);		
		
		QueueLoadTexture(defaultFaceTex,FaceTextureLoaded);		
		QueueLoadTexture(defaultTorsoTex,TorsoTextureLoaded);		
		QueueLoadTexture(defaultLimbsTex,LimbsTextureLoaded);		
		QueueLoadTexture(defaulGenstTex,GensTextureLoaded);				
	}

	public static JSONStorableUrl SetupTexture2DChooser(MVRScript self, string label, string defaultValue, bool rightSide, TextureSetCallback callback)
	{
			JSONStorableUrl storable = new JSONStorableUrl(label, defaultValue, (string url) => { QueueLoadTexture(url,callback); }, "jpg|png|tif|tiff");
			self.RegisterUrl(storable);
			//SuperController.LogError(defaultValue);	
			UIDynamicButton button = self.CreateButton(label, false);
			storable.suggestedPath = defaultDir;
			storable.RegisterFileBrowseButton(button.button);
			return storable;
	}



		private static void QueueLoadTexture(string url,TextureSetCallback callback)
		{	
			if (ImageLoaderThreaded.singleton == null)
			{
				return;
			}
			if (string.IsNullOrEmpty(url))
			{	
				return;
			}
			ImageLoaderThreaded.QueuedImage queuedImage = new ImageLoaderThreaded.QueuedImage();
			queuedImage.imgPath = url;	
			//SuperController.LogError(url);	
			queuedImage.forceReload = true;
			queuedImage.skipCache = true;
			queuedImage.compress = false;
			queuedImage.createMipMaps = false;
			queuedImage.isNormalMap = false;			
			queuedImage.linear = true;
			queuedImage.createAlphaFromGrayscale = false;
			queuedImage.createNormalFromBump = false;
			queuedImage.bumpStrength = 1.0f;
			queuedImage.isThumbnail = false;
			queuedImage.fillBackground = false;
			queuedImage.invert = false;
			queuedImage.callback = (ImageLoaderThreaded.QueuedImage qi) =>
			{
				Texture2D tex = qi.tex;
				if (tex != null)
				{	
					tex.wrapMode = TextureWrapMode.Clamp;
					tex.filterMode = FilterMode.Trilinear;
					tex.anisoLevel = 0;
				}						
				callback(tex);
			};
			ImageLoaderThreaded.singleton.QueueImage(queuedImage);			
		}

	public delegate void TextureSetCallback(Texture2D tex);
	
			private void FaceTextureLoaded(Texture2D tex)
			{		
				textureFace = tex;
			}

 			private void TorsoTextureLoaded(Texture2D tex)
			{	
				textureTorso = tex;
			}      		
		
			private void LimbsTextureLoaded(Texture2D tex)
			{		
				textureLimbs = tex;
			}		
		
			private void GensTextureLoaded(Texture2D tex)
			{	
			textureGens = tex;
			}		
		
		
		
		
		
		
		
		
//////////////////////  AssetLoader/////////////////////////////////////////
	
	
       class LoadAssetBundle : CustomYieldInstruction {
            AssetLoader.AssetBundleFromFileRequest req;
            private bool done;
            // We can't write the type AssetBundle, but we can call methods on it. lolwut C#
            public bool success => req.assetBundle != null;
            public T GetAsset<T>(string name) where T : UnityEngine.Object
            {
                return req.assetBundle?.LoadAsset<T>(name);
            }
            public LoadAssetBundle(string url)
            {
                req = new AssetLoader.AssetBundleFromFileRequest {
                    path = url,
                    callback = _ => {
                        done = true;
                        if (req.assetBundle == null)
                            AssetLoader.DoneWithAssetBundleFromFile(req.path);
                    }
                };
                AssetLoader.QueueLoadAssetBundleFromFile(req);
            }
            public override bool keepWaiting => !done;
        }
	        private IEnumerator AttemptLoadShader(string url)
        {              
            if (shader != null)
                yield break;
            var request = new LoadAssetBundle(url);
            yield return StartCoroutine(request);
            if (!request.success)
                yield break;
            shader = request.GetAsset<Shader>("Assets/EmissiveHack.shader");
			sssshader = request.GetAsset<Shader>("Assets/Resources folder/CP_SSSSS-master/CP_SSSSS_Shader.shader");
            maskShader = request.GetAsset<Shader>("Assets/Resources folder/CP_SSSSS-master/CP_SSSSS_Mask.shader");			
            copyDepthShader = request.GetAsset<Shader>("Assets/Resources folder/CP_SSSSS-master/CP_SSSSS_BlitDepthTextureToDepth.shader");
            sssshader2 = request.GetAsset<Shader>("Assets/Resources folder/CP_SSSSS-master/CP_VR_SSSSS_Shader.shader");
            maskShader2 = request.GetAsset<Shader>("Assets/Resources folder/CP_SSSSS-master/VAMCP_VR_SSSSS_Mask.shader");			
            copyDepthShader2 = request.GetAsset<Shader>("Assets/Resources folder/CP_SSSSS-master/VAMCP_SSSSS_BlitDepthTextureToDepth.shader");	
            tessShader = request.GetAsset<Shader>("Assets/Resources folder/CP_SSSSS-master/GeneratedFromSurface-TessellationBumpedSpecularSmooth2222.shader");
            tessShader2 = request.GetAsset<Shader>("Assets/Resources folder/CP_SSSSS-master/TessellationBumpedSpecularSmooth2222.shader");
            tessShader3 = request.GetAsset<Shader>("Assets/Shaders/TessellationSample.shader");
            tessShader4 = request.GetAsset<Shader>("Assets/Shaders/GeneratedFromSurface-TessellationSample3.shader");
            tessShader5 = request.GetAsset<Shader>("Assets/Shaders/EmissiveHack2.shader");
			shadowShader = request.GetAsset<Shader>("Assets/Shaders/UnlitWithShadowcaster2.shader");
			
			
			maskmaterial = new Material(maskShader);
			maskmaterial.SetColor("ScatteringColor", Color.red);
			blurshadermaterial = new Material(sssshader);
			copyDepthShadermaterial = new Material(copyDepthShader);
			maskmaterial2 = new Material(maskShader2);
			maskmaterial2.SetColor("ScatteringColor", Color.red);
			blurshadermaterial2 = new Material(sssshader2);
			copyDepthShadermaterial2 = new Material(copyDepthShader2);
		
			
            if (shader != null) {
                loadedShaderPath.val = url;
                loadedAssetBundle = true;
            } else {
                SuperController.LogError("Not found location in  assetbundle");
                AssetLoader.DoneWithAssetBundleFromFile(url);
            }
        }
		
		
        string GetPluginPath() // basically straight from VAMDeluxe's Dollmaster
        {
            string pluginId = this.storeId.Split('_')[0];
            string pathToScriptFile = manager.GetJSON(true, true)["plugins"][pluginId].Value;
            string pathToScriptFolder = pathToScriptFile.Substring(0, pathToScriptFile.LastIndexOfAny(new char[] { '/', '\\' }));
            return pathToScriptFolder;
        }		
		
	     protected IEnumerator LoadShaderAndInit()
        {
			yield return new WaitForEndOfFrame();
			if (shader == null) 
			{
                if (loadedShaderPath.val != "")
                    yield return AttemptLoadShader(loadedShaderPath.val);
				//SuperController.LogError("path"+GetPluginPath());

               yield return AttemptLoadShader($"Custom/Scripts/Hunting-Succubus/{BUNDLE_NAMEWIP}");
               yield return AttemptLoadShader($"{GetPluginPath()}/{BUNDLE_NAME}");
				
                if (shader == null || maskShader == null || copyDepthShader == null) 
				{
                    SuperController.LogError("main.Failed to load shader");
                    yield break;
                }
            }
			skin = _character.skin;
			
			if (skin == null)
			isLoading = true;
			else
			isLoading = false;
		
			StartCoroutine(QueueRescan());
        }	

	  private IEnumerator QueueRescan()
        {
         if (retryAttempts < 5 || (isLoading && retryAttempts < 200)) 
			{
             yield return new WaitForSeconds(0.2f);
             retryAttempts++;
             yield return nowStart();
            }
        }
		
		
    }

}